<template>
  <div id="class_notice_wrapper" class="bt-container">
    <el-breadcrumb style="font-size: 24px; margin-top: 40px; margin-bottom: 40px;" separator="|">
      <el-breadcrumb-item :to="{ path: `/a/${authType ? 'teacher' : 'student'}/NNclass/${classId}` }">{{ classData ? classData.name : '' }}</el-breadcrumb-item>
      <el-breadcrumb-item>{{ $t('CLASS_MENU.NOTICE') }}</el-breadcrumb-item>
      <div style="text-align: right;">
        <router-link :to="{ path: `/a/${authType ? 'teacher' : 'student'}/NNclass/${classId}` }">
          <el-button size="small">{{ $t('BOARD.BACK') }}</el-button>
        </router-link>
      </div> 
    </el-breadcrumb>
    <el-table
      :data="noticeList"
      @cell-click="onDetail"
      style="width: 100%"
      :empty-text="$t('BOARD.NODATA')">
      <el-table-column
        prop="num"
        width="80"
        :label="$t('LECTURE_LIST.NUMBER')"
        align='center'>
      </el-table-column>
      <el-table-column
        prop="name"
        :label="$t('BOARD.TITLE')">
      </el-table-column>
      <el-table-column
        prop="user.name"
        :label="$t('BOARD.CREATOR')"
        width="180">
      </el-table-column>
      <el-table-column
        prop="created_at"
        :label="$t('BOARD.REG_DATE')"
        width="230">
      </el-table-column>
      <el-table-column
        prop="num_views"
        :label="$t('BOARD.VIEWS')"
        width="180">
      </el-table-column>
    </el-table>

    <div>
      <el-select v-model="searchType" size="small" style="display: inline-block; width: 100px; margin-top: 40px;">
        <el-option
          v-for="option in selectOptionList"
          :key="option.value"
          :label="option.label"
          :value="option.value">
        </el-option>
      </el-select>

      <div style="display: inline-block; width: 200px;">
        <el-input :placeholder="$t('STUDENT_MENU.ENT_SEARCH_TERM')" v-model="searchWord" @keyup.enter="searchNotice"></el-input>
      </div>

      <el-button @click="searchNotice" icon="el-icon-search" circle></el-button>

      <el-button v-if="authType" size="small" style="float:right; margin-top: 40px;" @click="writeNotice" plain>{{ $t('BOARD.POST') }}</el-button>

      <el-pagination
        style="display: inline; float: right; margin-top: 40px;"
        layout="prev, pager, next"
        @current-change="refreshNotice"
        :current-page.sync="pageNum"
        :page-size="10"
        :total="total">
      </el-pagination>

    </div>
  </div>
</template>

<script>
import classService from '../../services/classService';
import utils from '../../utils';

export default {
  name: 'NNClassNotice',
  data() {
    return {
      classData: null,
      searchWord: '',
      searchType: 'name',
      type: '',
      query: '',
      noticeList: [],
      pageNum: 1,
      total: 0,
      selectOptionList: [{
        value: 'name',
        label: this.$t('BOARD.TITLE'),
      }, {
        value: 'user',
        label: this.$t('BOARD.CREATOR'),
      }],
    }
  },
  computed: {
    authType() {
      const vm = this;
      const jwt = vm.$store.state.auth.jwt;
      return utils.getAuthTypeFromJwt(jwt);
    },
    classId() {
      const vm = this;
      return Number.parseInt(vm.$route.params.classId, 10);
    },
  },
  async mounted() {
    const vm = this;

    vm.classData = (await classService.getClass({
      id: vm.classId
    })).data;

    await vm.refreshNotice();
  },
  methods: {
    async searchNotice() {
      const vm = this;

      vm.type = vm.searchType;
      vm.query = vm.searchWord;
      vm.pageNum = 1;
      await vm.refreshNotice();
    },
    writeNotice() {
      const vm = this;
      vm.$router.push(`/a/class/${vm.classId}/NNnoticeWrite`);
    },
    onDetail(row) {
      const vm = this;
      vm.$router.push(`/a/class/${vm.classId}/NNnoticedetail/${row.notice_id}`);
    },
    async refreshNotice(pageNum = 1) {
      const vm = this;

      const res = (await classService.getNoticeList({
        classId: vm.classId,
        pageNum: pageNum,
        type: vm.type,
        query: vm.query,
      })).data;
      vm.noticeList = res.result.map(refreshData => {
        refreshData.created_at = new Date(refreshData.created_at);
        refreshData.created_at = utils.formatDate(refreshData.created_at);
        refreshData.created_at = refreshData.created_at.toString();
        return {
          ...refreshData,
        };
      });

      // total 입력
      vm.total = res.total;
    }
  }

};
</script>